!!****m* ABINIT/interfaces_62_poisson
!! NAME
!! interfaces_62_poisson
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/62_poisson
!!
!! COPYRIGHT
!! Copyright (C) 2010-2011 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: config/scripts/abilint . .
!!
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module interfaces_62_poisson

 implicit none

interface
 subroutine Psolver_hartree(enhartr, hgrid, icoulomb, me, nfft, ngfft, nproc,&  
  &  nscforder, nspden, rhor, vhartr, usewvl)
  use defs_basis
  implicit none
  integer, intent(in) :: icoulomb
  integer, intent(in) :: me
  integer, intent(in) :: nfft
  integer, intent(in) :: nproc
  integer, intent(in) :: nscforder
  integer, intent(in) :: nspden
  integer, intent(in) :: usewvl
  real(dp), intent(out) :: enhartr
  integer, intent(in) :: ngfft(3)
  real(dp),intent(in) :: hgrid(3)
  real(dp),intent(in) :: rhor(nfft,nspden)
  real(dp),intent(out) :: vhartr(nfft)
 end subroutine Psolver_hartree
end interface

interface
 subroutine PSolver_kernel(iaction, hgrid, icoulomb, iproc, kernel_array, ngfft, nproc, nscforder)
  use defs_basis
  implicit none
  integer,intent(in) :: iaction
  integer,intent(in) :: icoulomb
  integer,intent(in) :: iproc
  integer,intent(in) :: nproc
  integer,intent(in) :: nscforder
  integer, intent(in) :: ngfft(3)
  real(dp),intent(in) :: hgrid(3)
  real(dp), pointer :: kernel_array(:)
 end subroutine PSolver_kernel
end interface

interface
 subroutine Psolver_rhohxc(enhartr, enxc, envxc, hgrid, icoulomb, ixc, me,&  
  &  mpi_enreg, nfft, nfft_pot, ngfft_tot, nproc, nscforder, nspden, rhor,&  
  &  vhartr, vxc, vxcavg, usewvl, xc_denpos)
  use defs_basis
  use defs_abitypes
  implicit none
  integer, intent(in) :: icoulomb
  integer, intent(in) :: ixc
  integer, intent(in) :: me
  integer, intent(in) :: nfft
  integer, intent(in) :: nfft_pot
  integer, intent(in) :: nproc
  integer, intent(in) :: nscforder
  integer, intent(in) :: nspden
  integer, intent(in) :: usewvl
  real(dp), intent(out) :: enhartr
  real(dp), intent(out) :: envxc
  real(dp), intent(out) :: enxc
  type(mpi_type), intent(inout) :: mpi_enreg
  real(dp), intent(out) :: vxcavg
  real(dp), intent(in) :: xc_denpos
  integer, intent(in) :: ngfft_tot(3)
  real(dp),intent(in) :: hgrid(3)
  real(dp),intent(inout) :: rhor(nfft, nspden)
  real(dp),intent(out) :: vhartr(nfft)
  real(dp),intent(out) :: vxc(nfft, nspden)
 end subroutine Psolver_rhohxc
end interface

end module interfaces_62_poisson
!!***
